using System;
using System.Linq;
using System.Collections.Generic;

using Microsoft.Xna.Framework;
using Monocle;
using MonoMod.RuntimeDetour;
using MonoMod.Utils;
using Celeste;
using Celeste.Mod;
using Celeste.Mod.Entities;

using Bitsbolts.Components;

namespace Bitsbolts.Entities {
  [Tracked]
  [CustomEntity("Bitsbolts/WorldCamera")]
  public class WorldCamera : Entity {
    internal Components.WorldCamera Camera;

    public WorldCamera(EntityData data, Vector2 offset) : base(data.Position + offset) {
      base.Visible = true;

      base.Add(this.Camera = new Components.WorldCamera(
        position: Vector2.Zero,
        target: data.NodesOffset(offset)[0],
        width: data.Width,
        height: data.Height
      ));

      var flags = data.Attr("flags").ParseFlagstrs();
      if (flags.Count > 0) {
        base.Add(new FlagstrListener {
          Flags = flags, TriggerOnAwake = true, OnAll = (enabled) => {
            this.Camera.Active = enabled;
          }
        });
      }
    }
  }
}
